clear
%
% tester avec step = 1, 2, 3, puis 4
step=4;
%
% G filtre de deconvolution
G='1./H';
%
% T parametre (en nb de pixels) lie au bouge horizontal
% reponse impulstionnelle du filtre qui rend l'image floue
T=200;
%
% load image
load load_rossignol ima
nb_NG=1000;
x=ima*nb_NG/max(ima(:));
%
h=fftshift(make_rect(T,1,size(x,2),size(x,1)));
%
% calcul des TF
X=fft2(x);
H=fft2(h);
%
% sortie du filtre qui rend l'image floue
y=ifft2(X.*H);
%
% quantification 
y=round(y);
%
figure(T);clf
subplot(2,3,1)
imagesc(x);axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
set(gca,'fontsize',14);title('x')
%
if step==1
    return
end
%
if step<=3
    subplot(2,3,2)
    imagesc(ifftshift(imdilate(h,ones(55))));axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
    set(gca,'fontsize',14);title('h')
    %
    subplot(2,3,3)
else
    subplot(2,3,2)
end
%
imagesc(y);axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
set(gca,'fontsize',14);title('y = conv(x,h)')
%
if step==2
    return
end
%
% analyse spectrale 
Y=fft2(y);
%
subplot(2,3,4)
imagesc(log10(fftshift(abs(X))));axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
set(gca,'fontsize',14);title('log_{10}|X|')
h=colorbar;set(h,'location','southoutside');vec=caxis;
%
if step==3
    subplot(2,3,5)
    imagesc(log10(fftshift(abs(H))));axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
    set(gca,'fontsize',14);title('log_{10}|Y|')
    h=colorbar;set(h,'location','southoutside');%caxis(vec);
    subplot(2,3,6)
else
    subplot(2,3,5)
end
imagesc(log10(fftshift(abs(Y))));axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
set(gca,'fontsize',14);title('log_{10}|Y|')
h=colorbar;set(h,'location','southoutside');caxis(vec);
%
if step==3
    return
end
%
% deconvolution
%
% les etudiants proposents :
eval(['GG=' G ';']);

z=real(ifft2(Y.*GG));
%
Z=fft2(z);

subplot(2,3,3)
imagesc(z);axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
set(gca,'fontsize',14);title('z = conv(y,g)')
%
subplot(2,3,6)
imagesc(log10(fftshift(abs(Z))));axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
set(gca,'fontsize',14);title('log_{10}|Z|')
h=colorbar;set(h,'location','southoutside');caxis(vec);
