clear
%
step=1; % analyse dans l'espace direct
%step=2; % analyse dans l'espace direct et en frquence
%step=3; % analyse du rsultat de la dconvolution
%step=4; % analyse du rsultat de la dconvolution
%step=5; % analyse du rsultat de la dconvolution
%
load load_rossignol ima
%
% Normalisation de l'image entre 0 et 1000
x=ima*1000/max(ima(:));
%
% filtre qui rend l'image floue
load load_h_floue h
%
% Application du filtre qui rend l'image floue
X=fft2(x);
H=fft2(h);
y0=ifft2(X.*H);
%
% Quantification de l'image entre 0 et 1000
y=round(y0);
%
% bruit additif gaussien
b=y-y0;
%
Y0=fft2(y0);
Y=fft2(y);
B=fft2(b);
%
if step>=3
    if step==3
        vec_alpha=0.000001;
    elseif step==4
        vec_alpha=0.01;
    elseif step==5
        vec_alpha=10.^linspace(-7,-2,100);
    end
    %
    vec_eqm=nan(size(vec_alpha));
    %
    for i=1:length(vec_alpha)
        alpha=vec_alpha(i);
        G=conj(H)./(alpha+abs(H).^2);
        z=real(ifft2(Y.*G));
        vec_eqm(i)=mean((z(:)-x(:)).^2);
    end
    %
    if length(vec_alpha)>1
        figure(3);clf
        loglog(vec_alpha,vec_eqm)
        set(gca,'fontsize',14)
        xlabel('\alpha')
        title('eqm')
    end
    %
    [~,i]=min(vec_eqm);
    %
    alpha=vec_alpha(i);
    G=conj(H)./(alpha+abs(H).^2);
    z=real(ifft2(Y.*G));
    Z=fft2(z);
else
    Z=NaN;
end
%
figure(1);clf
subplot(2,3,1)
imagesc(x);axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
set(gca,'fontsize',14);title('x')
%
subplot(2,3,2)
imagesc(y);axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
set(gca,'fontsize',14);title('y = x * h + b')
%
if step==1
    return
elseif step>=3
    subplot(2,3,3)
    imagesc(z);axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
    set(gca,'fontsize',14);title('z = y * g')
end
%
F=ones(60,1);
DSP_X=filter2(F,fftshift(abs(X).^2));
DSP_Y=filter2(F,fftshift(abs(Y).^2));
%
subplot(2,3,4)
imagesc(log10(DSP_X));axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
set(gca,'fontsize',14);title('\Gamma_{xx}')
h=colorbar;set(h,'location','southoutside');vec=caxis;
%
subplot(2,3,5)
imagesc(log10(DSP_Y));axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
set(gca,'fontsize',14);title('\Gamma_{yy}')
h=colorbar;set(h,'location','southoutside');caxis(vec);
%
if step>=3
    DSP_Z=filter2(F,fftshift(abs(Z).^2));
    %
    subplot(2,3,6)
    imagesc(log10(DSP_Z));axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
    set(gca,'fontsize',14);title('\Gamma_{zz}')
    h=colorbar;set(h,'location','southoutside');caxis(vec);
end
%
figure(2);clf
semilogy(abs(sum(abs(X).^2)),'linewidth',2);
hold on
h=semilogy(abs(sum(abs(Y0).^2)),'c','linewidth',2);
semilogy(abs(sum(abs(B).^2)),'g','linewidth',2);
semilogy(abs(sum(abs(Y).^2)),'r','linewidth',2);
semilogy(abs(sum(abs(Z).^2)),'k','linewidth',2);
set(gca,'xlim',[1 length(y)/3])
set(gca,'ylim',[10^4 10^16])
set(gca,'fontsize',14);
if step>=3
    L=legend('X','XH','B','Y',['Z (\alpha = ' num2str(alpha) ')']);
else
    L=legend('X','XH','B','Y');
end
title('Densites spectrales de puissante \Gamma(\nu)')
xlabel('\nu')

set(L,'location','eastOutside')
%
