clear
%
% duree de l'acquisition
T=0.1; % secondes
%T=1; % secondes
%T=10; % secondes
%T=100; % secondes
%
% Estimation de la DSP
Delta_nu1=100;  % 100
Delta_nu2=0;    % 0, puis 20
%
% fin input
%==========
%
% nu_e : frequence d'chantillonnage
nu_e=10^4;
%
% N : nb de points
N=round(T*nu_e/2);
%
% generation de fonction alatoires
%
rng('default')
%
rand;rand;rand;
% nombre de modes
nb_modes=3+floor(rand*18);
%
X=zeros(N,1);
%
for n=1:nb_modes
    %
    puiss_du_mode=10^(1+round(rand*4));
    %
    X=X+rand*retard_entier(blackman(N).^puiss_du_mode,round(N*rand));
end
%
% calcul de la DSP (dans les frquence positives
DSP=abs(X).^0.5;
%
% filtre passe bas pour respecter Shannon
fen=bartlett(length(DSP)*2);
DSP=DSP.*fen(end/2+1:end);
%
% construction des frquences ngatives
%
% le premier est rel car c'est la moyenne
% celui du milieu est rel car sinon, a marche pas non plus
DSP=[DSP;rand;DSP(end:-1:2)];
%
N=length(DSP);
%
% on gnre de nouvelle ralisation de bruit
rng('shuffle');
%
z=randn(N,1);
x=real(ifft(fft(z).*sqrt(DSP)));
%
f=0:(N-1);
f=f/N*nu_e;
%
clf
subplot(3,1,1)
t=1:N;
t=(t-1)/nu_e;
plot(t,x,'linewidth',2)
xlabel('n/T_e [s]')
set(gca,'fontsize',16)
set(gca,'xlim',[t(1) t(end)])
title(['x_n avec T = ' num2str(T) ' s' ...
    ', et \nu_e = ' num2str(nu_e/1000) ' kHz'])
%
% fft
X=fft(x);
subplot(3,1,2)
plot(f(1:end/2)/1000,abs(X(1:end/2)),'k','linewidth',2);
set(gca,'fontsize',16)
grid on
title('|X_k|')
xlabel('k/T [kHz]')
%
if (Delta_nu1==0)&&(Delta_nu2==0)
    return
end
% welch
%
if Delta_nu1>0
    Lg=round(nu_e/Delta_nu1);
    if T>1
        rec=1;
    else
        rec=round(Lg*0.1);
    end
    if T>1
        NN=N/100;
        ind=1:round(NN);
        for r=1:100
            iind=round((r-1)*N/100)+ind;
            xx=x(iind);
            if r==1
                [DSP_est1,f_est]=pwelch(xx,hanning(Lg),rec,NN,nu_e,'twosided');
            else
                DDSP_est1=pwelch(xx,hanning(Lg),rec,NN,nu_e,'twosided');
                DSP_est1=DSP_est1+DDSP_est1;
            end
        end
        DSP_est1=DSP_est1/100;
    else
        [DSP_est1,f_est]=pwelch(x,hanning(Lg),rec,N,nu_e,'twosided');
    end
end
%
if Delta_nu2>0
    Lg=round(nu_e/Delta_nu2);
    if T>1
        rec=1;
    else
        rec=round(Lg*0.1);
    end
    if T>1
        NN=N/100;
        ind=1:round(NN);
        for r=1:100
            iind=round((r-1)*N/100)+ind;
            xx=x(iind);
            if r==1
                [DSP_est2,f_est]=pwelch(xx,hanning(Lg),rec,NN,nu_e,'twosided');
            else
                DDSP_est2=pwelch(xx,hanning(Lg),rec,NN,nu_e,'twosided');
                DSP_est2=DSP_est2+DDSP_est2;
            end
        end
        DSP_est2=DSP_est2/100;
    else
        DSP_est2=pwelch(x,hanning(Lg),rec,N,nu_e,'twosided');
    end
end

subplot(3,1,3)
%plot(f(1:end/2)/1000,DSP(1:end/2),'k','linewidth',2);hold on
plot(f_est(1:end/2)/1000,nu_e*DSP_est1(1:end/2),'b-','linewidth',2);
set(gca,'fontsize',16)
hold on
if Delta_nu2>0
    plot(f_est(1:end/2)/1000,nu_e*DSP_est2(1:end/2),'r-','linewidth',2);
end
grid on
if Delta_nu2==0
    legend(['\Gamma(\nu) estime avec \Delta_{\nu} = ' num2str(Delta_nu1) ' Hz'])
else
    legend(['\Gamma(\nu) estime avec \Delta_{\nu} = ' num2str(Delta_nu1) ' Hz'], ...
    ['\Gamma(\nu) estime avec \Delta_{\nu} = ' num2str(Delta_nu2) ' Hz'])
end
xlabel('k/T [kHz]')
set(gca,'ylim',[0 1.5])