clear
%
% ajout de bruit
sigma=0.01;
%sigma=1;
%
%NN=[];
NN=4;
%
% fin input
%==========
%
% coefficient d'un polynme
p=[1 -1 1 -1 2 -2 3 -3 4 -4];
%
% coordonnes du polynme
x=linspace(-1,1,10);
y=polyval(p,x);
z=y+sigma*randn(size(y));
%
N=length(p);
p_est = polyfit(x,z,N-1);
%
if ~isempty(NN)
    p_est_bis = polyfit(x,z,NN-1);
end

xx=linspace(x(1),x(end),1000);
yy=polyval(p,xx);
yy_est=polyval(p_est,xx);

% plots
clf
plot(xx,yy,'b','linewidth',2)
ylim=get(gca,'ylim');
hold on
h=plot(x,z,'xk','markersize',12,'linewidth',2);
plot(xx,yy_est,'r--','linewidth',2)
if isempty(NN)
    L=legend(['polynme de degr ' num2str(length(p)-1) ' (sans bruit)'], ...
        'mesures bruites', ...
        ['estimation d''un poly. de degr = ' num2str(N-1)]);
else
    yy_est_bis=polyval(p_est_bis,xx);
    plot(xx,yy_est_bis,'g--','linewidth',2)
    L=legend(['polynme de degr ' num2str(length(p)-1) ' (sans bruit)'], ...
        'mesures bruites', ...
        ['estimation d''un poly. de degr ' num2str(N-1)], ...
        ['estimation d''un poly. de degr ' num2str(NN-1)]);
end
grid on
set(L,'Location','southeast')
%
set(gca,'FontSize',14)
set(gca,'ylim',ylim);
%