clear
close all
%
% taille de la base d'apprentissage
P=100;
%
% dimension
N=2;
%
% type de frontiere
choix_frontiere=2;
%
rng(1);
%
% coordonnees des vecteurs de la base
X=randn(N,P);
%
if choix_frontiere==1
    % classe de chacun des vecteurs
    C=randn(1,P);
else
    w=randn(N,1);
    C=w'*X;
end
C=C>0;
%
if N==3
    vec_essai=1;
else
    if choix_frontiere==1
        vec_essai=1:2;
    elseif choix_frontiere==2
        vec_essai=1:3;
    end
end
%
for essai=vec_essai
    figure(essai+10*(choix_frontiere-1))
    clf
    if essai==2
        [v,c]=voronoin(X');
        %set(x(1),'Marker','.','markersize',1,'color','k')
        %set(x(2),'color','b','linewidth',2)
        %
        for i=1:length(c)
            if C(i)==1
                couleur=1;
            else
                couleur=2;
            end
            if all(c{i}~=1)
                if N==2
                    patch(v(c{i},1),v(c{i},2),couleur)
                elseif N==3
                    if couleur==1
                        patch(v(c{i},1),v(c{i},2),v(c{i},3),couleur)
                    end
                end
            end
        end
        caxis([0 2])
    elseif essai==3
        x=linspace(-1,1,1000);
        [mat_x,mat_y]=meshgrid(x,x);
        %
        XX=[mat_x(:)';mat_y(:)'];%randn(N,P);
        CC=w'*XX;
        CC=CC>0;
        CC=reshape(CC,length(x),length(x));
        imagesc(x,x,CC==0)
        axis xy
        caxis([-1 1])
    end
    %
    hold on
    if N==2
        ind=C==1;
        plot(X(1,ind),X(2,ind),'.b','markersize',16)
        ind=C==0;
        plot(X(1,ind),X(2,ind),'.r','markersize',16)
    elseif N==3
        ind=C==1;
        plot3(X(1,ind),X(2,ind),X(3,ind),'.b','markersize',16)
        ind=C==0;
        plot3(X(1,ind),X(2,ind),X(3,ind),'.r','markersize',16)
    end
    %
    for n=1:P
        if max(abs(X(:,n)))<1
            if N==2
                h=text(X(1,n),X(2,n),num2str(n));
            else
                h=text(X(1,n),X(2,n),X(3,n),num2str(n));
            end
            set(h,'HorizontalAlignment','left')
            set(h,'VerticalAlignment','top','fontsize',14)
        end
    end
    %
    set(gca,'fontsize',14)
    axis equal
    xlabel('x_1')
    ylabel('x_2')
    if essai==1
        title('base d''apprentissage')
    elseif essai==2
        title('diagramme de Voronoi')
    elseif essai==3
        title('frontiere lineaire')
    end
    %
    set(gca,'xlim',[-1 1])
    set(gca,'ylim',[-1 1])
    if N==3
        set(gca,'zlim',[-1 1])
    end
end
%
if N==2
    figure(10*(choix_frontiere-1)+2)
    figure(10*(choix_frontiere-1)+1)
end
