function y=retard_freq(x,ret)
%
% y=retard_freq(x,ret)
%
% implemente numeriquement y(t)=x(t-tau);
%
% si x est une matrice, alors le retard est applique sur les colonnes
%
% variable d'entree
%==================
% x : vecteur ou matrice 
% ret : scalaire correspondant a la valeur du retard
%
% variable de sortie
%===================
% y : vecteur ou une matrice


%
if ~isscalar(ret)
    disp(' ')
    disp('ret doit etre un scalaire dans retard_freq.m')
    disp(' ')
    return
end
%
if isvector(x)
    nbt=length(x);
else
    [nbt,nbc]=size(x);
end
%
% freq est le vecteur des frequences reduites de -0.5 a 0.5
freq=0:nbt-1;
freq=freq/nbt;
freq(freq>0.5)=freq(freq>0.5)-1;
%
if isvector(x)
    %
    % test pour savoir si x est un vecteur ligne ou colonne
    [~,nbc]=size(x);
    %
    if nbc==1
        freq=freq(:);
    end
    %
    % application du retard par dephasage en frequence
    vec=exp(-2*pi*1i*freq*ret);
    %
    Y=fft(x).*vec;
    %
    % gestion de la frequence 1/2
    if floor(nbt/2)==nbt/2
        Y(nbt/2+1)=real(Y(nbt/2+1)); 
    end
    %
    % retour dans l'espace direct
    y=ifft(Y);
    %
elseif length(size(x))==2
    %
    % application du retard par dephasage en frequence
    mat=exp(-2*pi*1i*ret*freq(:)*ones(1,nbc));
    %
    Y=fft(x).*mat;
    %
    % gestion de la frequence 1/2
    if floor(nbt/2)==nbt/2
        Y(nbt/2+1,:)=real(Y(nbt/2+1,:));
    end
    %
    % retour dans l'espace direct
    y=ifft(Y);
    %
end
%
y=real(y);
%
end
